/******************************************************************
 * File: expr_token.hh
 *
 * This file was automatically generated by CppCC Version 0.0.8
 * DO NOT EDIT MANUALLY
 ******************************************************************/


#ifndef __EXPR_TOKEN_HH__
#define __EXPR_TOKEN_HH__

#include <string>
#include <sstream>

namespace cppcc
{

class Position
{
  public:
    Position () : ln(0), col(0) {}
    Position (int ln_, int col_) : ln(ln_), col(col_) {}
    Position (const Position &o) : ln(o.ln), col(o.col) {}
    
    operator std::string () const
    {
      std::ostringstream oss;
      oss << ln << ":" << col;
      return oss.str();
    }
    
    int ln, col;
};

class ExprToken
{
  friend class ExprScanner;
  public:
    
    ExprToken () : _img_valid(true) {}
    ExprToken (int id_, const std::string &_str_img_, 
              const Position &bPos_, const Position &ePos_) :
      _str_img(_str_img_), _img_valid(true), id(id_), bPos(bPos_), ePos(ePos_)
    {}
    ExprToken (int id_, const Position &bPos_, const Position &ePos_) :
      _img_valid(true), id(id_), bPos(bPos_), ePos(ePos_)
    {}
    ExprToken (int id_) : 
      _img_valid(true), id(id_)
    {}
    ExprToken (const std::string &_str_img_) : 
      _str_img(_str_img_), _img_valid(true)
    { length = _str_img.length(); }
    ExprToken (int id_, const Position &bPos_) :
      _img_valid(true), id(id_), bPos(bPos_), ePos(bPos_)
    {}
  
  public:
    Position bPos, ePos;
    int id;
    int length;
    std::string& image()
    {
      _cacheImg();
      return _str_img;
    }
  
  private:
    const char *_img_start; //points into the scanner's buffer
    bool _img_valid; //true if the string image is in sync with the buffer
    std::string _str_img; //caches the image as a string
    
    void _set (int id_, const Position &bPos_, const Position &ePos_,
               const char *_img_start_, int length_)
    {
      id = id_; bPos = bPos_; ePos = ePos_;
      _img_start = _img_start_; length = length_;
      _img_valid = false;
    }
    
    void _set (const char *_img_start_, int length_)
    {
      _img_start = _img_start_; length = length_;
      _img_valid = false;
    }
    void _cacheImg()
    {
      if (!_img_valid) {
        _str_img.assign(_img_start, length);
        _img_valid = true;
      }
    }
    
  private: // user code
  
#line 11 "expression.cg"

#line 99 "expr_token.hh"

  
   /* Token id constants: */
  public:
  
    static const int eof;
    static const int ws;
    static const int eol;
    static const int PLUS;
    static const int MINUS;
    static const int TIMES;
    static const int FRAC;
    static const int LP;
    static const int RP;
    static const int NUMBER;
    
}; // end of ExprToken class


} // end namespace cppcc
#endif // ifndef __EXPR_TOKEN_HH__


/* End of file. */
